#include "assets.hpp"
#include "Objects/paco.hpp"
#include <PSX/AutoLBA/auto_lba_declaration.hpp>
#include <stdio.h>

namespace Assets {
    using namespace object;

    enum LBA {
        __jabyengine_start_lba_request
        __jabyengine_request_lba_for(FONT, "ASSETS/MAIN/FONT.BIN"),
        __jabyengine_request_lba_for(PACO, "ASSETS/MAIN/PACO.BIN"),
        __jabyengine_end_lba_request
    };

    __declare_lba_header(LBA);

    void load_for_main() {
        static const CDFile Assets[] = {
            CDFileBuilder::simple_tim(LBA::FONT, FontTIM),
            CDFileBuilder::simple_tim(LBA::PACO, Paco::TIM),
        };

        const auto      buffer_cfg = CDFileProcessor::BufferConfiguration::new_default();
        CDFileProcessor file_processor;

        file_processor.setup(lba, Assets, buffer_cfg);
        while(true) {
            switch(file_processor.process()) {
                case Progress::InProgress:
                    break;

                case Progress::Done:
                    if(!file_processor.next(lba, buffer_cfg)) {
                        return;
                    }
                    break;
                
                case Progress::Error:
                    printf("Error detected! Aborting load\n");
                    return;
            }
        }
    }
}