#pragma once
#include <PSX/System/IOPorts/periphery_io.hpp>
#include <PSX/System/IOPorts/interrupt_io.hpp>

namespace JabyEngine {
    namespace Periphery {
        using namespace Periphery_IO;

        static void busy_cycle(uint32_t cycles) {
            while(cycles--) {
                asm("");
            }
        }

        static void connect_to(uint16_t port) {
            JOY_CTRL.write(JOY_CTRL::create_for(port));
            busy_cycle(500);
        }

        static void close_connection() {
            JOY_CTRL.write(JOY_CTRL::close());
        }

        static void acknowledge() {
            while(JOY_STAT.read().is_set(JOY_STAT::ACKIrqLow));
            JOY_CTRL.write(JOY_CTRL.read().set(JOY_CTRL::ACK));
            
            Interrupt::ack_irq(Interrupt::Periphery);
        }
    }
}